## z3 4.4.0

=== src/api/ml/Makefile ===
# This is a temporary support file for emacs annotations. 
# It does not compile the Z3 ML API; this will be built 
# in the top-level build directory.

all: 
	ocamlbuild -cflag -annot z3.cmxa

doc: *.ml
	mkdir -p doc
	ocamldoc -html -d doc -I _build -sort *.mli -hide Z3

=== debian/changelog ===
z3 (4.4.0-3build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 04 Nov 2015 14:05:46 -0600

z3 (4.4.0-3) unstable; urgency=low

  * De-duplicate files in python-z3, depend on libz3-dev instead
  * Added bindings for java, OCaml, and .NET
  * Use multi-arch library locations

 -- Michael Tautschnig <mt@debian.org>  Thu, 27 Aug 2015 15:18:46 +0100

z3 (4.4.0-2) unstable; urgency=low

  * Added __init__.py. Thanks Andrea Villa for the hints. (Closes: #791604)
  * Use emmintrin.h conditionally only (Closes: #789881)

 -- Michael Tautschnig <mt@debian.org>  Tue, 07 Jul 2015 08:08:48 +0100

z3 (4.4.0-1) unstable; urgency=low

  * Initial release (Closes: #786807)
  * Includes patches from unstable branch up to 6a50f10b8b

 -- Michael Tautschnig <mt@debian.org>  Wed, 17 Jun 2015 21:40:44 +0100

=== debian/control ===
Source: z3
Section: science
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>=9),
               dh-python, python,
               javahelper, default-jdk,
               ocaml-nox, dh-ocaml,
               mono-mcs, cli-common-dev (>=0.8~),
                 libmono-system-numerics4.0-cil
Standards-Version: 3.9.6
Homepage: https://github.com/Z3Prover/z3

Package: z3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research
 Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
 used to check the satisfiability of logical formulas over one or more
 theories. Z3 offers a compelling match for software analysis and verification
 tools, since several common software constructs map directly into supported
 theories.
 .
 The Z3 input format is an extension of the one defined by the SMT-LIB 2.0
 standard.

Package: libz3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research - development files
 Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
 used to check the satisfiability of logical formulas over one or more
 theories. Z3 offers a compelling match for software analysis and verification
 tools, since several common software constructs map directly into supported
 theories.
 .
 This package can be used to invoke Z3 via its C++ API.

Package: python-z3
Section: python
Architecture: any
Multi-Arch: same
Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research - Python bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its Python API.

Package: libz3-cil
Section: cli-mono
Architecture: any
Multi-Arch: same
Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${cli:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research - CLI bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its .NET API.

Package: libz3-ocaml-dev
Section: libdevel
Architecture: any
Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: ocaml-findlib
Description: theorem prover from Microsoft Research - OCaml bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its OCaml API.

Package: libz3-java
Section: java
Architecture: any
Multi-Arch: same
Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${java:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research - java bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its Java API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --with python2,javahelper,ocaml,cli

override_dh_auto_configure:
	python scripts/mk_make.py --java --ml --prefix=$(CURDIR)/debian/tmp/usr
	sed -i 's/^SLINK_FLAGS=.*/SLINK_FLAGS=-shared $(LDFLAGS) -Wl,-soname,libz3.so.4/' build/config.mk
	sed -i 's/^CXXFLAGS=/CXXFLAGS=-fPIC /' build/config.mk
	printf '%%:\n\t$$(MAKE) -C build $$@\n' > Makefile
	printf '\nall:\n\t$$(MAKE) -C build $$@\n' >> Makefile
	ln -s libz3.so build/libz3.dll
	# from T2 README, with fixes
	printf '<configuration>\n <dllmap dll="libz3.dll" target="/usr/lib/$(DEB_HOST_MULTIARCH)/libz3.so" os="linux"/>\n</configuration>\n' > build/Microsoft.Z3.dll.config

override_dh_clean:
	dh_clean
	$(RM) Makefile scripts/*.pyc
	$(RM) -r build
	$(RM) src/api/python/*.pyc
	$(RM) \
    src/api/api_commands.cpp \
    src/api/api_log_macros.cpp \
    src/api/api_log_macros.h \
    src/api/dll/gparams_register_modules.cpp \
    src/api/dll/install_tactic.cpp \
    src/api/dll/mem_initializer.cpp \
    src/api/dotnet/Enumerations.cs \
    src/api/dotnet/Native.cs \
    src/api/dotnet/Properties/AssemblyInfo.cs \
    src/api/python/z3consts.py \
    src/api/python/z3core.py \
    src/api/java/Native.cpp \
    src/api/java/Native.java \
    src/api/java/enumerations/Z3_ast_kind.java \
    src/api/java/enumerations/Z3_ast_print_mode.java \
    src/api/java/enumerations/Z3_decl_kind.java \
    src/api/java/enumerations/Z3_error_code.java \
    src/api/java/enumerations/Z3_goal_prec.java \
    src/api/java/enumerations/Z3_lbool.java \
    src/api/java/enumerations/Z3_param_kind.java \
    src/api/java/enumerations/Z3_parameter_kind.java \
    src/api/java/enumerations/Z3_sort_kind.java \
    src/api/java/enumerations/Z3_symbol_kind.java \
    src/api/ml/z3native.ml \
    src/api/ml/z3native.mli \
    src/api/ml/z3native_stubs.c \
    src/api/ml/z3enums.ml \
    src/api/ml/z3enums.mli \
    src/ast/fpa/fpa2bv_rewriter_params.hpp \
    src/ast/normal_forms/nnf_params.hpp \
    src/ast/pattern/database.h \
    src/ast/pattern/pattern_inference_params_helper.hpp \
    src/ast/pp_params.hpp \
    src/ast/rewriter/arith_rewriter_params.hpp \
    src/ast/rewriter/array_rewriter_params.hpp \
    src/ast/rewriter/bool_rewriter_params.hpp \
    src/ast/rewriter/bv_rewriter_params.hpp \
    src/ast/rewriter/fpa_rewriter_params.hpp \
    src/ast/rewriter/poly_rewriter_params.hpp \
    src/ast/rewriter/rewriter_params.hpp \
    src/ast/simplifier/arith_simplifier_params_helper.hpp \
    src/ast/simplifier/array_simplifier_params_helper.hpp \
    src/ast/simplifier/bv_simplifier_params_helper.hpp \
    src/interp/interp_params.hpp \
    src/math/polynomial/algebraic_params.hpp \
    src/math/realclosure/rcf_params.hpp \
    src/model/model_evaluator_params.hpp \
    src/model/model_params.hpp \
    src/muz/base/fixedpoint_params.hpp \
    src/nlsat/nlsat_params.hpp \
    src/parsers/util/parser_params.hpp \
    src/sat/sat_asymm_branch_params.hpp \
    src/sat/sat_params.hpp \
    src/sat/sat_scc_params.hpp \
    src/sat/sat_simplifier_params.hpp \
    src/shell/gparams_register_modules.cpp \
    src/shell/install_tactic.cpp \
    src/shell/mem_initializer.cpp \
    src/smt/params/smt_params_helper.hpp \
    src/solver/combined_solver_params.hpp \
    src/tactic/sls/sls_params.hpp \
    src/test/gparams_register_modules.cpp \
    src/test/install_tactic.cpp \
    src/test/mem_initializer.cpp \
    src/util/version.h \
    src/opt/opt_params.hpp


override_dh_auto_test:
	$(MAKE) test-z3
	build/test-z3 -a
	$(RM) interval_lemma_* trigo-lemmas.math

override_dh_auto_install:
	mkdir -p debian/tmp/usr/lib/python2.7/dist-packages/z3
	dh_auto_install
	touch debian/tmp/usr/lib/python2.7/dist-packages/z3/__init__.py
	$(RM) debian/tmp/usr/lib/python2.7/dist-packages/libz3.so
	ln -s ../../$(DEB_HOST_MULTIARCH)/libz3.so \
		debian/tmp/usr/lib/python2.7/dist-packages/libz3.so
	mv debian/tmp/usr/lib/libz3.so debian/tmp/usr/lib/libz3.so.4
	ln -s libz3.so.4 debian/tmp/usr/lib/libz3.so
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jni
	mv debian/tmp/usr/lib/libz3java.so* \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jni/
	mv debian/tmp/usr/lib/libz3.so* \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES
	for p in python-z3 libz3-ocaml-dev libz3-cil libz3-java ; do \
		$(RM) -rf debian/$$p/usr/share/doc/$$p/ ; \
		ln -s libz3-dev debian/$$p/usr/share/doc/$$p ; \
	done

## z3 4.4.1

=== debian/changelog ===
z3 (4.4.1-1~deb10u1) buster; urgency=medium

  * Non-maintainer upload.
  * Rebuild for buster.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 24 Aug 2019 12:18:35 +0200

z3 (4.4.1-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team Upload
  * Upload to unstable

  [ Andreas Beckmann ]
  * Do not set the SONAME of libz3java.so to libz3.so.4.  (Closes: #842892)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Aug 2019 11:05:53 +0200

z3 (4.4.1-0.5~exp1) experimental; urgency=medium

  * Package moved to salsa (Closes: #926939)
  * Standards-Version updated to 4.2.1
  * Fix priority-extra-is-replaced-by-priority-optional warning
  * Moved under the llvm umbrella

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 Apr 2019 14:30:31 +0200

z3 (4.4.1-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove the incorrect Multi-Arch: same of python-z3,
    thanks to Helmut Grohne. (Closes: #874237)

 -- Adrian Bunk <bunk@debian.org>  Sun, 09 Sep 2018 22:28:32 +0300

z3 (4.4.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.

  [ Fabian Wolff ]
  * debian/patches/f02d273ee39ae047222e362c37213d29135dc661.patch:
    Fix build failure with new gnu++14 standard. (Closes: #835754)
  * debian/patches/27399309009314f56cdfbd8333f287b1a9b7a3a6.patch:
    Fix build failure with new compiler and clang. (Closes: #835743)

  [ Gianfranco Costamagna ]
  * debian/patches/fix-build.patch: tweak the casts a little bit
    more to really fix 835743.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 25 Sep 2016 23:06:24 +0200

z3 (4.4.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch kfreebsd.patch to attempt to fix a FTBFS on kfreebsd-*.
  * Adjust avoid-ocamlopt.patch to remove all calls to ocamlopt.
  * Build libz3-cil only where Mono is available.
  * Build libz3-jni and libz3-java only where Java is available.
  * Remove enable-dotnet.patch and recreate its effect with sed in
    debian/rules depending on whether Mono is available or not.
  * Disable some tests that might fail on some platforms.
    Forwarded: https://github.com/Z3Prover/z3/issues/687
  * Enable hardening flags for libz3-ocaml-dev.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Tue, 19 Jul 2016 23:02:19 +0200

z3 (4.4.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
  * Remove patches that were fixed upstream:
     - signed_char01
     - signed_char02
     - signed_char03
     - signed_char04
     - disable_test
     - disable_test2
     - disable_test3
     - disable_test4 (upstream issue has been closed:
        https://github.com/Z3Prover/z3/issues/210)
     - fix_conflict
  * Migrate remaining patches to DEP-3 format.
  * Rewrite typos.patch to apply to new version of z3.
  * Add patch fix-dotnet-version.patch to fix a FTBFS with Mono caused
    by an apparently unsupported version of the .NET framework
    (Closes: #808695).
  * Add patch disable-tests.patch to disable three potentially failing
    tests in src/test/main.cpp.
  * Install shared libraries into new libz3-4 package (Closes: #819884).
  * Remove ${shlibs:Depends} and ${misc:Pre-Depends} substitution
    variables from libz3-dev entry in debian/control.
  * Install python files directly into /usr/lib/python2.7/dist-packages/
    (Closes: #802272).
  * Clean up debian/rules.
  * Remove unnecessary version restriction of build dependency
    cli-common-dev.
  * Fix debian/copyright: Change MIT to Expat and delete file block that
    no longer applies (copyright of hamiltonian.py changed).
  * Move libz3-ocaml-dev into section ocaml.
  * Add preinst scripts to remove directories from older versions to allow
    debhelper to install symlinks (Closes: #823573).
  * Enable hardening flags in debian/rules.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Wed, 13 Jul 2016 17:33:19 +0200

z3 (4.4.0-5) unstable; urgency=low

  * Add fixes for tests previously failing on ARM, PowerPC

 -- Michael Tautschnig <mt@debian.org>  Sun, 04 Oct 2015 10:57:27 +0100

z3 (4.4.0-4) unstable; urgency=low

  * Add libz3-jni package to split out arch-specific files from java package.
    (Closes: #797515)
  * Don't claim multi-arch compatibilty of libz3-cil. (Closes: #797514)
  * ocamlopt isn't universally available, and never actually used in the build
    process.

 -- Michael Tautschnig <mt@debian.org>  Fri, 04 Sep 2015 13:55:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,20 @@
 Source: z3
 Section: science
-Priority: extra
-Maintainer: Michael Tautschnig <mt@debian.org>
+Priority: optional
+Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Uploaders: Michael Tautschnig <mt@debian.org>
 Build-Depends: debhelper (>=9),
                dh-python, python,
-               javahelper, default-jdk,
+               javahelper [!hppa !hurd-i386 !m68k !sh4],
+               default-jdk [!hppa !hurd-i386 !m68k !sh4],
                ocaml-nox, dh-ocaml,
-               mono-mcs, cli-common-dev (>=0.8~),
-                 libmono-system-numerics4.0-cil
-Standards-Version: 3.9.6
+               mono-mcs [!mips !mips64el !powerpc !alpha !hppa !hurd-i386 !m68k !powerpcspe !ppc64 !sh4 !sparc64 !x32],
+               cli-common-dev [!mips !mips64el !powerpc !alpha !hppa !hurd-i386 !m68k !powerpcspe !ppc64 !sh4 !sparc64 !x32],
+               libmono-system-numerics4.0-cil [!mips !mips64el !powerpc !alpha !hppa !hurd-i386 !m68k !powerpcspe !ppc64 !sh4 !sparc64 !x32]
+Standards-Version: 4.2.1
 Homepage: https://github.com/Z3Prover/z3
+Vcs-Git: https://salsa.debian.org/pkg-llvm-team/z3.git
+Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/z3
 
 Package: z3
 Architecture: any
@@ -24,11 +29,29 @@
  The Z3 input format is an extension of the one defined by the SMT-LIB 2.0
  standard.
 
+Package: libz3-4
+Architecture: any
+Multi-Arch: same
+Section: libs
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Breaks: libz3-dev (<< 4.4.1)
+Replaces: libz3-dev (<< 4.4.1)
+Description: theorem prover from Microsoft Research - runtime libraries
+ Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
+ used to check the satisfiability of logical formulas over one or more
+ theories. Z3 offers a compelling match for software analysis and verification
+ tools, since several common software constructs map directly into supported
+ theories.
+ .
+ This package contains runtime libraries. You shouldn't have to install it
+ manually.
+
 Package: libz3-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: libz3-4 (= ${binary:Version}), ${misc:Depends}
 Description: theorem prover from Microsoft Research - development files
  Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
  used to check the satisfiability of logical formulas over one or more
@@ -41,7 +64,7 @@
 Package: python-z3
 Section: python
 Architecture: any
-Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
 Description: theorem prover from Microsoft Research - Python bindings
  Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
@@ -51,8 +74,7 @@
 
 Package: libz3-cil
 Section: cli-mono
-Architecture: any
-Multi-Arch: same
+Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel ppc64el s390x
 Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${cli:Depends}, ${shlibs:Depends}
 Description: theorem prover from Microsoft Research - CLI bindings
  Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
@@ -61,7 +83,7 @@
  This package can be used to invoke Z3 via its .NET API.
 
 Package: libz3-ocaml-dev
-Section: libdevel
+Section: ocaml
 Architecture: any
 Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Recommends: ocaml-findlib
@@ -73,12 +95,24 @@
 
 Package: libz3-java
 Section: java
-Architecture: any
-Multi-Arch: same
-Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${java:Depends}, ${shlibs:Depends}
+Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel powerpc ppc64el s390x alpha kfreebsd-amd64 kfreebsd-i386 powerpcspe sparc64 x32
+Multi-Arch: foreign
+Depends: libz3-jni (>= ${binary:Version}), libz3-jni (<< ${source:Version}.1~), libz3-dev, ${misc:Depends}, ${java:Depends}
 Description: theorem prover from Microsoft Research - java bindings
  Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
  package for a detailed description.
  .
  This package can be used to invoke Z3 via its Java API.
 
+Package: libz3-jni
+Section: java
+Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel powerpc ppc64el s390x alpha kfreebsd-amd64 kfreebsd-i386 powerpcspe sparc64 x32
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Description: theorem prover from Microsoft Research - JNI library
+ Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
+ package for a detailed description.
+ .
+ This package provides the JNI library to invoke Z3 via its Java API.
+

=== debian/rules ===
--- 
+++ 
@@ -1,23 +1,48 @@
 #!/usr/bin/make -f
-# -*- makefile -*-
-# Sample debian/rules that uses debhelper.
-# This file was originally written by Joey Hess and Craig Small.
-# As a special exception, when this file is copied by dh-make into a
-# dh-make output file, you may use that output file without restriction.
-# This special exception was added by Craig Small in version 0.37 of dh-make.
 
 # Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
+# export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+ifneq (,$(shell dh_listpackages -a | grep libz3-cil))
+    WITH_MONO ?= yes
+else
+    WITH_MONO ?= no
+endif
+
+ifneq (,$(shell dh_listpackages -a | grep libz3-jni))
+    WITH_JAVA ?= yes
+else
+    WITH_JAVA ?= no
+endif
+
 %:
-	dh $@ --parallel --with python2,javahelper,ocaml,cli
+	if [ $(WITH_JAVA) = yes ]; then \
+		if [ $(WITH_MONO) = yes ]; then \
+			dh $@ --parallel --with python2,javahelper,ocaml,cli; \
+		else \
+			dh $@ --parallel --with python2,javahelper,ocaml; \
+		fi; \
+	else \
+		dh $@ --parallel --with python2,ocaml; \
+	fi
 
 override_dh_auto_configure:
-	python scripts/mk_make.py --java --ml --prefix=$(CURDIR)/debian/tmp/usr
-	sed -i 's/^SLINK_FLAGS=.*/SLINK_FLAGS=-shared $(LDFLAGS) -Wl,-soname,libz3.so.4/' build/config.mk
-	sed -i 's/^CXXFLAGS=/CXXFLAGS=-fPIC /' build/config.mk
+	if [ $(WITH_MONO) = yes ]; then \
+		sed -i 's/^DOTNET_ENABLED=.*/DOTNET_ENABLED=True/' scripts/mk_util.py; \
+	else \
+		sed -i 's/^DOTNET_ENABLED=.*/DOTNET_ENABLED=False/' scripts/mk_util.py; \
+	fi
+	if [ $(WITH_JAVA) = yes ]; then \
+		python scripts/mk_make.py --java --ml --prefix=$(CURDIR)/debian/tmp/usr; \
+	else \
+		python scripts/mk_make.py --ml --prefix=$(CURDIR)/debian/tmp/usr; \
+	fi
+	sed -i 's/^SLINK_FLAGS=/SLINK_FLAGS=$$(LDFLAGS) -fPIC /' build/config.mk
+	echo 'libz3$$(SO_EXT): SLINK_FLAGS += -Wl,-soname,libz3.so.4' >> build/Makefile
 	printf '%%:\n\t$$(MAKE) -C build $$@\n' > Makefile
 	printf '\nall:\n\t$$(MAKE) -C build $$@\n' >> Makefile
 	ln -s libz3.so build/libz3.dll
@@ -26,6 +51,7 @@
 
 override_dh_clean:
 	dh_clean
+	sed -i 's/^DOTNET_ENABLED=.*/DOTNET_ENABLED=False/' scripts/mk_util.py
 	$(RM) Makefile scripts/*.pyc
 	$(RM) -r build
 	$(RM) src/api/python/*.pyc
@@ -104,24 +130,32 @@
 	$(RM) interval_lemma_* trigo-lemmas.math
 
 override_dh_auto_install:
-	mkdir -p debian/tmp/usr/lib/python2.7/dist-packages/z3
+	mkdir -p debian/tmp/usr/lib/python2.7/dist-packages/
 	dh_auto_install
-	touch debian/tmp/usr/lib/python2.7/dist-packages/z3/__init__.py
 	$(RM) debian/tmp/usr/lib/python2.7/dist-packages/libz3.so
 	ln -s ../../$(DEB_HOST_MULTIARCH)/libz3.so \
 		debian/tmp/usr/lib/python2.7/dist-packages/libz3.so
 	mv debian/tmp/usr/lib/libz3.so debian/tmp/usr/lib/libz3.so.4
 	ln -s libz3.so.4 debian/tmp/usr/lib/libz3.so
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jni
-	mv debian/tmp/usr/lib/libz3java.so* \
+	-mv debian/tmp/usr/lib/libz3java.so* \
 		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jni/
 	mv debian/tmp/usr/lib/libz3.so* \
 		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
 
+override_dh_install:
+	dh_install
+	-cp build/api/ml/*.cmxa debian/libz3-ocaml-dev/usr/lib/ocaml/z3/
+	-cp build/api/ml/*.cmx debian/libz3-ocaml-dev/usr/lib/ocaml/z3/
+
 override_dh_installchangelogs:
 	dh_installchangelogs RELEASE_NOTES
-	for p in python-z3 libz3-ocaml-dev libz3-cil libz3-java ; do \
+	for p in python-z3 libz3-ocaml-dev libz3-cil libz3-java libz3-jni ; do \
 		$(RM) -rf debian/$$p/usr/share/doc/$$p/ ; \
-		ln -s libz3-dev debian/$$p/usr/share/doc/$$p ; \
+		ln -s libz3-dev debian/$$p/usr/share/doc/$$p || true ; \
 	done
 
+override_dh_clideps:
+	# dh_clideps fails to find libz3.so automatically
+	# So we have to depend on libz3-dev manually in d/control
+	dh_clideps --exclude-moduleref=libz3
